<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfBasicUnitInfoTypeContactNumber ArrayType
 * @subpackage Arrays
 */
class ArrayOfBasicUnitInfoTypeContactNumber extends AbstractStructArrayBase
{
    /**
     * The ContactNumber
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\ContactNumber[]
     */
    public $ContactNumber;
    /**
     * Constructor method for ArrayOfBasicUnitInfoTypeContactNumber
     * @uses ArrayOfBasicUnitInfoTypeContactNumber::setContactNumber()
     * @param \StructType\ContactNumber[] $contactNumber
     */
    public function __construct(array $contactNumber = array())
    {
        $this
            ->setContactNumber($contactNumber);
    }
    /**
     * Get ContactNumber value
     * @return \StructType\ContactNumber[]|null
     */
    public function getContactNumber()
    {
        return $this->ContactNumber;
    }
    /**
     * This method is responsible for validating the values passed to the setContactNumber method
     * This method is willingly generated in order to preserve the one-line inline validation within the setContactNumber method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateContactNumberForArrayConstraintsFromSetContactNumber(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfBasicUnitInfoTypeContactNumberContactNumberItem) {
            // validation for constraint: itemType
            if (!$arrayOfBasicUnitInfoTypeContactNumberContactNumberItem instanceof \StructType\ContactNumber) {
                $invalidValues[] = is_object($arrayOfBasicUnitInfoTypeContactNumberContactNumberItem) ? get_class($arrayOfBasicUnitInfoTypeContactNumberContactNumberItem) : sprintf('%s(%s)', gettype($arrayOfBasicUnitInfoTypeContactNumberContactNumberItem), var_export($arrayOfBasicUnitInfoTypeContactNumberContactNumberItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ContactNumber property can only contain items of type \StructType\ContactNumber, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ContactNumber value
     * @throws \InvalidArgumentException
     * @param \StructType\ContactNumber[] $contactNumber
     * @return \ArrayType\ArrayOfBasicUnitInfoTypeContactNumber
     */
    public function setContactNumber(array $contactNumber = array())
    {
        // validation for constraint: array
        if ('' !== ($contactNumberArrayErrorMessage = self::validateContactNumberForArrayConstraintsFromSetContactNumber($contactNumber))) {
            throw new \InvalidArgumentException($contactNumberArrayErrorMessage, __LINE__);
        }
        $this->ContactNumber = $contactNumber;
        return $this;
    }
    /**
     * Add item to ContactNumber value
     * @throws \InvalidArgumentException
     * @param \StructType\ContactNumber $item
     * @return \ArrayType\ArrayOfBasicUnitInfoTypeContactNumber
     */
    public function addToContactNumber(\StructType\ContactNumber $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ContactNumber) {
            throw new \InvalidArgumentException(sprintf('The ContactNumber property can only contain items of type \StructType\ContactNumber, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ContactNumber[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ContactNumber|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ContactNumber|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ContactNumber|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ContactNumber|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ContactNumber|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ContactNumber
     */
    public function getAttributeName()
    {
        return 'ContactNumber';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfBasicUnitInfoTypeContactNumber
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
